;*******************************************************
;                       POZ.LSP
;                  
;-------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq lay (getvar "clayer") rgm (getvar "REGENMODE")
  tst (getvar "textstyle"))
 (setvar "CMDECHO" 0)
 (setvar "BLIPMODE" 1)
 (setvar "REGENMODE" 0)
 (command "LAYER" "m" "tt" "c" "3" "tt" (command))
 (command "COLOR" "bylayer")
 (command "LINETYPE" "s" "bylayer" (command))
 (command "STYLE" "tt" "eskd" 4 0.9 15
  "n" "n" "n"))

;             
(defun rvars ()
 (command "LAYER" "s" lay (command))
 (command "TEXT" "s" tst (command))
 (setvar "BLIPMODE" 1)
 (setvar "CMDECHO" 1)
 (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))
;                  
(defun C:POZ (/ pv rp chp xpv ypv xrp yrp np pt tpp dt p
  npu lay rgm tst oerr)
 (svars)
 (initget 1)
 (setq pv (getpoint "\n  : "))
 (initget 1)
 (setq rp (getpoint pv "\n .: "))
 (initget 6)
 (setq chp (getint "\n  <1>: "))
 (if (not chp) (setq chp 1))
 (setq xpv (car pv) ypv (cadr pv)
       xrp (car rp) yrp (cadr rp))
 (if (<= xpv xrp)
  (setq np 0 pt (list (+ xrp 5) (+ yrp 2)))
  (setq np pi pt (list (- xrp 5) (+ yrp 2))))
 (setvar "BLIPMODE" 0)
 (command "CIRCLE" pv "d" 0.7 (command))
 (command "LINE" pv rp (command))
 (command "LINE" rp (polar rp np 10) (command))
 (if (> chp 1) (progn
   (command "ARRAY" "l" "" "r" chp 1 -10 (command))
   (command "LINE" rp (polar rp (/ (* 3 pi) 2)
     (* (1- chp) 10)) (command)))
  (progn (setq tpp (getstring T "\n  : "))
   (setq dt (* (strlen tpp) 3.5))
   (if (< dt 10) (setq dt 10))
   (if (/= tpp "") (progn (command "LINE" rp
      (setq p (polar rp (/ (* 3 pi) 2) 10))
      (polar p np dt) (command))
     (command "TEXT" "c" (polar (polar rp np (/ dt 2))
       (/ (* 3 pi) 2) 8) 0 tpp)))))
 (if (not npz) (setq npz 0))
 (repeat chp (setq npu (1+ npz))
  (princ (strcat "\n  <" (itoa npu) ">: "))
  (initget 6)
  (setq npz (getint))
  (if (not npz) (setq npz npu))
  (command "TEXT" "c" pt 0 (itoa npz))
  (setq pt (polar pt (/ (* 3 pi) 2) 10)))
  (rvars)
 (prin1))