;*****************************************************
;                       REZ.LSP
;             (  )
;-----------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE")  rgm (getvar "REGENMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" 0)
 (command "LAYER" "s" "0" "")
 (command "COLOR" "bylayer")
 (command "LINETYPE" "s" "bylayer" (command)))

;             
(defun rvars ()
 (command "COLOR" clr)
 (command "LAYER" "s" lay "")
 (command "LINETYPE" "s" tln (command))
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))

;                 
(defun C:REZ (/ vr cr di scf tr dn dv do dd ap os dice
  clr lay tln rgm oerr)
 (svars)
;                   
 (initget 1 "I i O o")
 (setq vr (getkword "\n    - O
        - I: "))
 (initget 1)
 (setq cr (getpoint "\n: "))
 (initget 7)
 (setq di (getdist cr "\n : "))
 (setvar "BLIPMODE" 0) (setvar "HIGHLIGHT" 0)
 (initget 6)
 (setq scf (getreal "\n  <1>: "))
 (if (not scf) (setq scf 1.0))
 (cond ((or (= di 1) (= di 1.2))
              (setq tr 0.25))
  ((= di 1.4) (setq tr 0.30))
  ((= di 1.6) (setq tr 0.35))
  ((= di 2)   (setq tr 0.40))
  ((= di 2.5) (setq tr 0.45))
  ((= di 3)   (setq tr 0.50))
  ((= di 3.5) (setq tr 0.60))
  ((= di 4)   (setq tr 0.70))
  ((= di 5)   (setq tr 0.80))
  ((= di 6)   (setq tr 1.00))
  ((= di 8)   (setq tr 1.25))
  ((>= di 10) (setq tr 1.50))
  (T nil))
 (setq dn (* di scf) tr (* tr scf))
 (if (< tr 1.5) (setq tr 1.5))
 (if (< dn 3) (setq dn 3.0))
 (setq dv (- dn tr))
 (if (= (strcase vr) "O")
  (setq do dn dd dv) (setq do dv dd dn))
 (command "CIRCLE" cr (/ do 2))
 (command "COLOR" "3")
 (command "ARC" "c" cr (setq ap
  (polar cr (/ (* 7 pi) 12) (/ dd 2))) "a" 270)
 (setq os (getstring "\n ? <N>: "))
 (if (= (strcase (substr os 1 1)) "Y") (progn
   (setq dice (getvar "DIMCEN"))
   (setvar "DIMCEN" (+ (/ dn 2) 1.0))
   (command "DIM" "center" ap (command))
   (setvar "DIMCEN" dice)))
 (rvars)
 (prin1))