;*******************************************************
;                       TT.LSP
;          -  
;-------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq lay (getvar "clayer") rgm (getvar "REGENMODE")
  tst (getvar "textstyle"))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 0)
 (setvar "REGENMODE" 0)
 (command "LAYER" "m" "tt" "c" "3" "tt" (command))
 (command "COLOR" "bylayer")
 (command "LINETYPE" "s" "bylayer" (command))
 (command "STYLE" "tt" "eskd" 4 0.9 15
  "n" "n" "n"))

;             
(defun rvars ()
 (command "LAYER" "s" lay (command))
 (command "TEXT" "s" tst (command))
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))

;          
(defun convert (stin / n ltt letter stroka)
 (setq stroka "" n 1)
 (while (> (1+ (strlen stin)) n)
  (setq ltt (ascii (substr stin n 1)))
  (cond ((and (< 127 ltt) (> 176 ltt)) (setq ltt (+ ltt 912)))
   ((and (< 223 ltt) (> 240 ltt)) (setq ltt (+ ltt 864)))
   (t nil))
  (setq letter (base 16 ltt))
  (if (= (strlen letter) 2)
   (setq letter (strcat "\\U+00" letter))
   (setq letter (strcat "\\U+0" letter)))
  (setq stroka (strcat stroka letter))
  (setq n (1+ n)))
 (setq stout stroka))

; BASE converts from a decimal integer to a string in another base
(defun BASE ( bas int / ret yyy zot )
 (defun zot ( i1 i2 / xxx )
  (if (> (setq xxx (rem i2 i1)) 9)
   (chr (+ 55 xxx))
   (itoa xxx)))
 (setq ret (zot bas int) yyy (/ int bas))
 (while (>= yyy bas)
  (setq ret (strcat (zot bas yyy) ret))
  (setq yyy (/ yyy bas)))
 (strcat (zot bas yyy) ret))

;                  
(defun C:TT (/ ftt kor pt f st lay rgm tst oerr stin stout osnap_def)
 (svars)
 (setq ftt (getfiled "  ..." "" "" 4))
 (initget "Y y N n")
 (setq kor (getkword "\n  <Y/N>? <N>: "))
 (if (or (= kor "Y") (= kor "y")) (command "EDIT" ftt))
 (setq pt (getpoint "\n  : ")
  f (open ftt "r"))
 (setq osnap_def (getvar "OSMODE")) 
 (setvar "OSMODE" 0)
 (while (setq st (read-line f))
  (setq stt (convert st))
  (command "TEXT" pt 0 stt)
  (setq pt (polar pt (* pi 1.5) 12)))
 (close f)
 (rvars)
 (setvar "OSMODE" osnap_def)
 (prin1))