;**********************************************************
;                       APL1.LSP
;         ARC, CIRCLE, LINE  PLINE
;       (c w = 0.0)     
;       PLINE ( w = 0.3).
;          .
;----------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE") rgm (getvar "REGENMODE"))
 (setvar "BLIPMODE" 0) (setvar "CMDECHO" 0)
 (setvar "HIGHLIGHT" 0) (setvar "REGENMODE" 0)
 (setvar "TEXTEVAL" 1)
 (command "COLOR" "bylayer")
 (command "LINETYPE" "s" "bylayer" "")
 (command "UNDO" "c" "n"))

;             
(defun rvars ()
 (command "COLOR" clr)
 (command "LAYER" "s" lay "")
 (command "LINETYPE" "s" tln "")
 (command "UNDO" "a")
 (setvar "BLIPMODE" 1) (setvar "CMDECHO" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setvar "TEXTEVAL" 0)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))
;                    
(defun C:APL1 (/ spr lnr n k npr nbl r nr d ltpr tp p lpr
  xl yl limf rb rot dwgn drf fplt df clr lay tln rgm oerr)
 (svars)

;           
 (setvar "CMDECHO" 1)
 (command "SAVE" pause (command))
 (setvar "CMDECHO" 0)

;             
 (setq spr (ssget "X" '((0 . "INSERT"))) lnr '())
 (if spr (while (ssname spr 0)
  (setq n (sslength spr) k (1- n))
  (repeat n (setq npr (ssname spr k)
    nbl (cdr (assoc 2 (entget npr))) k (1- k))
   (if (and (/= (substr nbl 1 2) "*X")
     (= (cdr (assoc 41 (entget npr)))
      (cdr (assoc 42 (entget npr)))))
    (progn (initget "N n Y y")
     (setq r (getkword (strcat
         "\n  " nbl " ? <Y>: ")))
     (if (not r) (setq r "Y"))
     (if (= (strcase r) "Y")
      (command "EXPLODE" npr (command))
      (setq lnr (cons npr lnr))))
    (setq lnr (cons npr lnr))))
  (setq spr (ssget "X" '((0 . "INSERT"))))
  (foreach nr lnr (setq spr (ssdel nr spr)))))

;  ARC, CIRCLE, LINE, PLINE ( w = 0.0)
;            PLINE ( w = 0.3)
 (setq d (getreal "\n Pline  <0.3>: "))
 (if (not d) (setq d 0.3))
 (setq ltpr (list "ARC" "CIRCLE" "LINE" "POLYLINE")
  lpr '())
 (foreach tp ltpr
  (setq spr (ssget "X" (list (cons 0 tp))))
  (if spr (progn
    (setq n (sslength spr) k (1- n))
    (repeat n (setq npr (ssname spr k) k (1- k))
     (if (or (= (cdr (assoc 62 (entget npr))) 7)
       (and (or (= (cdr (assoc 62 (entget npr))) nil)
         (= (cdr (assoc 62 (entget npr))) 0))
        (= (cdr (assoc 62 (tblsearch "LAYER"
            (cdr (assoc 8 (entget npr)))))) 7)))
      (setq lpr (cons npr lpr)))))))
 (foreach p lpr
  (cond ((or (= (cdr (assoc 0 (entget p))) "ARC")
     (= (cdr (assoc 0 (entget p))) "LINE"))
    (command "PEDIT" p "y" "w" d "x"))
   ((and (= (cdr (assoc 0 (entget p))) "POLYLINE")
     (= (cdr (assoc 40 (entget p)))
      (cdr (assoc 41 (entget p))) 0))
    (command "PEDIT" p "w" d "x"))
   ((= (cdr (assoc 0 (entget p))) "CIRCLE")
    (command "LAYER" "s" (cdr (assoc 8 (entget p))) "")
    (command "PLINE" (polar (cdr (assoc 10 (entget p)))
      0 (cdr (assoc 40 (entget p)))) "w" d "" "a" "ce"
     (cdr (assoc 10 (entget p))) "a" 180 "cl")
    (entdel p))
   (T nil)))
 (rvars)
 (prin1))