;**********************************************************
;                        DIA.LSP
;                    
;----------------------------------------------------------
;             
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE") tst (getvar "TEXTSTYLE")
  rgm (getvar "REGENMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" 0))

;           
(defun rvars ()
 (command "COLOR" clr)
 (command "LAYER" "s" lay (command))
 (command "LINETYPE" "s" tln (command))
 (command "TEXT" "s" tst (command))
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;          
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))
;                  
(defun C:DIA (/ en pt co r pc ts np u tp pro scf di ok ok1
  ok2 ok3 rt n pr sz drt unp kp du ut dd osnap_def)
 (svars);        

;                    
 (setq en (entsel "\n  ()\n"))
 (if (/= (cdr (assoc 0 (entget (car en)))) "CIRCLE")
  (if (/= (cdr (assoc 0 (entget (car en)))) "ARC")
   (setq en nil)))
 (while (not en) (setq en (entsel
    "\n  , \n")))
 (initget 1)
 (setq co (cdr (assoc 10 (entget (car en)))))
 (setq pt (getpoint co "\n : "))
 (setq r (cdr (assoc 40 (entget (car en))))
  pc (distance pt co) u (angle pt co))
 (if (> pc r) (progn
   (initget 1 "I O N i o n")
   (setq ts (strcase
     (getkword "\n:\n -       <i>,
 -      <o>,\n -   <n>: ")))
   (while (and (= ts "O") (< pc (+ r 6)))
    (initget 1)
    (setq pt (getpoint co "\n  ,
 : ") pc (distance pt co) u (angle pt co)))
   (initget 1)
   (setq np (getpoint "\n : ")))
  (progn
   (while (or (and (> u (/ pi 2)) (<= u (/ pi 1.5)))
     (and (> u (* 1.5 pi)) (<= u (/ pi 0.6))))
    (setq pt (getpoint co "\n  : ")
     u (angle pt co)))
   (cond ((or (> u (/ pi 0.6)) (<= u (/ pi 2)))
     (setq du (/ pi 2) ut u))
    ((and (> u (/ pi 1.5)) (<= u (* 1.5 pi)))
     (setq du (/ pi -2) ut (- u pi)))
    (T nil))))
 (setq tp (getstring T "\n    : "))
 (setq pro (getstring T
   "\n   (  ): "))
 (initget 6)
 (setq scf (getreal "\n   <1>: "))
 (if (not scf) (setq scf 1.0))
 (setvar "BLIPMODE" 0);          
 (setvar "HIGHLIGHT" 0);         
 (setq osnap_def (getvar "OSMODE")) 
 (setvar "OSMODE" 0)
;                   :
;  -   (   
;      -  ),
;  -  ,
;  -   
 (setq di (/ (* 2 r) scf))
 (setq ok1 (rtos di 2 2))
 (if (/= "0" (substr ok1 (strlen ok1) 1))
  (setq ok ok1))
 (if (=  "0" (substr ok1 (strlen ok1) 1)) (progn
   (setq ok2 (substr ok1 1 (- (strlen ok1) 1)))
   (if (/= "0" (substr ok2 (strlen ok2) 1))
    (setq ok ok2))
   (if (=  "0" (substr ok2 (strlen ok2) 1)) (progn
     (setq ok3 (substr ok2 1 (- (strlen ok1) 3)))
     (setq ok ok3)))))
 (princ "\n   <")
 (princ (strcat tp " " "@" ok pro))
 (princ "> :")
 (setq rt (getstring T))
 (if (= rt "")  (setq rt (strcat tp " " "@" ok pro)))
 (setq n 1 pr 0 sz 0)
 (repeat (strlen rt)
  (cond ((= (substr rt n 1) "%") (setq pr (1+ pr)))
   ((= (substr rt n 1) (chr 212)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 214)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 215)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 216)) (setq sz (1+ sz)))
   (T nil))
  (setq n (1+ n)))
 (setq drt (* (- (strlen rt) sz (/ pr 0.4)) 2.5))

;   ,    ,  
 (command "COLOR" "bylayer")
 (command "LAYER" "m" "dim" "c" 3 "dim" (command))
 (command "LINETYPE" "s" "bylayer" (command))
 (command "STYLE" "dim" "eskd" 3.5 0.9 15
  "n" "n" "n")
 
;         , ,
;       (  )   
;       
 (if (> pc r) (progn
   (if (< (car np) (car pt))
    (setq unp pi)
    (setq unp 0))
   (if (and (< (cadr pt) (cadr co))
     (or (and (= unp pi) (< (car co) (car pt)))
      (and (= unp 0) (> (car co) (car pt)))))
    (setq kp (polar pt unp (+ drt 10)))
    (setq kp (polar pt unp (+ drt 1))))
   (cond ((= ts "I") (command "LINE" kp pt
      (polar pt u (+ pc r)) (command))
     (command "PLINE" (polar co u r) "w" 0 1.3
      (polar co u (- r 4.5)) "w" 0 0 (command))
     (command "PLINE" (polar co (+ u pi) r) "w" 0 1.3
      (polar co (+ u pi) (- r 4.5)) "w" 0 0 (command)))
    ((= ts "O") (command "LINE" kp pt
      (polar pt u (+ pc r 8)) (command))
     (command "PLINE" (polar co u r) "w" 0 1.3
      (polar co u (+ r 4.5)) "w" 0 0 (command))
     (command "PLINE" (polar co (+ u pi) r) "w" 0 1.3
      (polar co (+ u pi) (+ r 4.5)) "w" 0 0 (command)))
    ((= ts "N") (command "LINE" kp pt
      (polar pt u pc) (command))
     (command "CIRCLE" co "d" 0.7 (command)))
    (T nil))
   (cond ((= unp pi)
     (command "TEXT" (polar kp (/ pi 2) 2) 0 rt))
    ((= unp 0)
     (command "TEXT" "r" (polar kp (/ pi 2) 2) 0 rt))
    (T nil))))
 (if (<= pc r) (progn
   (command "LINE" (polar co u r) (polar co (+ u pi) r)
    (command))
   (command "PLINE" (polar co u r) "w" 0 1.3
    (polar co u (- r 4.5)) "w" 0 0 (command))
   (command "PLINE" (polar co (+ u pi) r) "w" 0 1.3
    (polar co (+ u pi) (- r 4.5)) "w" 0 0 (command))
   (command "TEXT" "c" (polar co (+ u du) 2)
    (angtos ut 0 2) rt)))
 (if (= (cdr (assoc 0 (entget (car en)))) "ARC") (progn
   (initget "n N y Y")
   (setq dd (strcase
     (getkword "\n  ? <N>: ")))
   (if (= dd "Y") (command "ARC"
     (polar co (cdr (assoc 51 (entget (car en)))) r) "c" co
     (polar co (cdr (assoc 50 (entget (car en)))) r)))))
 (rvars);          
 (setvar "OSMODE" osnap_def)
 (prin1))