;**********************************************************
;                        DOL.LSP
;                    
;            (  )
;                   
;----------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE") tst (getvar "TEXTSTYLE")
  rgm (getvar "REGENMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 0) (setvar "REGENMODE" 0))

;             
(defun rvars ()
 (command "COLOR" clr)
 (command "LAYER" "s" lay (command))
 (command "LINETYPE" "s" tln (command))
 (command "TEXT" "s" tst (command))
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))

;              
(defun scroll (l)
 (append (cdr l) (list (car l))))

;                   
(defun C:DOL (/ vir t0 nt tn lt kt prl ltr ltv ltt lr lx ly
  yrl lxt ut pu pr xrl lyt scf po lrt dstr ok ok1 ok2 ok3
  rt n clr lay tln tst rgm oerr osnap_def)
 (svars);           

;                   
 (initget 1 "g v G V")
 (setq vir (getkword "\n   - <g>
            - <v>: "))
 (setq t0 (getpoint "\n   : "))
 (setq nt 1 tn t0 lt (list t0))
 (while tn
  (setq tn (getpoint (strcat
     "\n  " (itoa nt) "- : "))
   lt (cons tn lt) nt (1+ nt)))
 (setq lt (cdr lt) kt (length lt))
 (setq prl (getpoint "\n   : "))
 (setvar "BLIPMODE" 0);        
 (setq osnap_def (getvar "OSMODE")) 
 (setvar "OSMODE" 0)
;        
 (setq ltr '() ltv '() ltt '() lr '())
 (if (= (strcase vir T) "g") (progn
   (setq yrl (cadr prl) lxt '() ut 90)
   (repeat kt (setq lx '())
    (foreach %t lt (setq lx (cons (car %t) lx)))
    (while (/= (car (car lt)) (apply 'max lx))
     (setq lt (scroll lt)))
    (setq lr (cons (car lt) lr) lt (cdr lt)))
   (setq lt lr lr nil lx nil)
   (foreach %t lt
    (setq lxt (append lxt (list (car %t)))))
   (cond ((< (car t0) (last lxt))  (setq pu pi))
    ((= (car t0) (last lxt))
     (setq pu 0 lt (reverse lt) lxt (reverse lxt)))
    (T nil))
   (cond ((< (cadr t0) yrl)  (setq pr 1))
    ((> (cadr t0) yrl)  (setq pr -1))
    (T nil))
   (foreach %x lxt
    (setq ltr (append ltr (list (list %x yrl)))
     ltv (append ltv (list (list %x (+ yrl (* pr 1.5)))))
     ltt (append ltt
      (list (list (+ %x 1.7) (+ yrl (* pr 4.0)))))))))

;        
 (if (= (strcase vir T) "v") (progn
   (setq xrl (car prl) lyt '() ut 0)
   (repeat kt (setq ly '())
    (foreach %t lt (setq ly (cons (cadr %t) ly)))
    (while (/= (cadr (car lt)) (apply 'max ly))
     (setq lt (scroll lt)))
    (setq lr (cons (car lt) lr) lt (cdr lt)))
   (setq lt lr lr nil ly nil)
   (foreach %t lt
    (setq lyt (append lyt (list (cadr %t)))))
   (cond ((< (cadr t0) (last lyt))  (setq pu (* 1.5 pi)))
    ((= (cadr t0) (last lyt))
     (setq pu (* 0.5 pi) lt (reverse lt) lyt (reverse lyt)))
    (T nil))
   (cond ((< (car t0) xrl)  (setq pr 1))
    ((> (car t0) xrl)  (setq pr -1))
    (T nil))
   (foreach %y lyt
    (setq ltr (append ltr (list (list xrl %y)))
     ltv (append ltv (list (list (+ xrl (* pr 1.5)) %y)))
     ltt (append ltt (list (list
        (+ xrl (* pr 4.0)) (- %y 1.7))))))))

;                   :
;  -  ,
;  -   (   ),
;  -       
;     (      -
;     ),
;  -  
 (initget 6)
 (setq scf (getreal "\n   <1>: "))
 (if (not scf) (setq scf 1.0))
 (setq po (getstring T
   "\n   (  ): "))
 (if (/= po "") (setq po (strcat " " po)))
 (setq lrt '())
 (foreach %r ltr
   (setq dstr (/ (distance (nth 0 ltr) %r) scf))
   (setq ok1 (rtos dstr 2 2))
   (if (/= "0" (substr ok1 (strlen ok1) 1))
    (setq ok ok1))
   (if (=  "0" (substr ok1 (strlen ok1) 1)) (progn
     (setq ok2 (substr ok1 1 (- (strlen ok1) 1)))
     (if (/= "0" (substr ok2 (strlen ok2) 1))
      (setq ok ok2))
     (if (=  "0" (substr ok2 (strlen ok2) 1)) (progn
       (setq ok3 (substr ok2 1 (- (strlen ok1) 3)))
       (setq ok ok3)))))
   (if (/= ok "0") (progn
     (princ "\n   <")
     (princ (strcat ok po)) (princ "> :")
     (setq rt (getstring T))
     (if (= rt "")  (setq rt (strcat ok po))))
    (setq rt ok))
   (setq lrt (append lrt (list rt))))

;   ,    ,  
 (command "COLOR" "bylayer")
 (command "LAYER" "m" "dim" "c" 3 "dim" (command))
 (command "LINETYPE" "s" "bylayer" (command))
 (command "STYLE" "dim" "eskd" 3.5 0.9 15
  "n" "n" "n")

;      (),  ,
;         
 (setq n 0)
 (while (< n (1- (length ltr)))
  (if (>= (distance (nth n ltr) (nth (1+ n) ltr)) 5.5)
   (command "pline" (nth (1+ n) ltr) "w" 0 1.3
    (polar (nth (1+ n) ltr) pu 4.5) "w" 0 0 (command))
   (command "line" (list (- (car (nth (1+ n) ltr)) 1.0)
     (- (cadr (nth (1+ n) ltr)) 1.0))
    (list (+ (car (nth (1+ n) ltr)) 1.0)
     (+ (cadr (nth (1+ n) ltr)) 1.0)) (command)))
  (setq n (1+ n)))
 (command "line" (nth 0 ltr) (last ltr) (command))
 (command "circle" (nth 0 ltr) "d" 0.7 (command))
 (mapcar '(lambda (p v) (command "line" p v (command)))
  lt ltv)
 (mapcar '(lambda (a b)
   (cond ((= pr 1) (command "text" a ut b))
    ((= pr -1) (command "text" "r" a ut b))
    (T nil))) ltt lrt)
 (rvars);           
 (setvar "OSMODE" osnap_def)
 (prin1))