;**********************************************************
;                        DV.LSP
;                    
;----------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE") tst (getvar "TEXTSTYLE")
  rgm (getvar "REGENMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 0) (setvar "REGENMODE" 0))

;             
(defun rvars ()
 (command "COLOR" clr)
 (command "LAYER" "s" lay (command))
 (command "LINETYPE" "s" tln (command))
 (command "TEXT" "s" tst (command))
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))
;              
(defun C:DV (/ fp sp xfp xsp yfp ysp dp xdp ydp fp1 sp1 m1
  b1 fp2 sp2 u scf po dstr ok ok1 ok2 ok3 rt n pr sz drt
  ytp stre str osnap_def)
 (svars);    

;                 
 (initget 1)
 (setq fp (getpoint "\n  :\n "))
 (setq sp (getpoint "\n  : "))
 (setq xfp (car fp) xsp (car sp) yfp (cadr fp)
  ysp (cadr sp))
 (while (and (= yfp ysp) (/= xfp xsp)) (initget 1)
  (setq sp (getpoint "\n    : ")
   xsp (car sp) ysp (cadr sp)))
 (setq dp (getpoint "\n  : ")
  xdp (car dp) ydp (cadr dp))
 (while (= yfp ysp ydp) (initget 1) (setq dp
   (getpoint "\n    : ")
  xdp (car dp) ydp (cadr dp)))
 (setvar "BLIPMODE" 0);    
 (setq osnap_def (getvar "OSMODE")) 
 (setvar "OSMODE" 0)
;             
 (setq fp1 (list xdp yfp) sp1 (list xdp ysp)
  m1 (list xdp (min yfp ysp)) b1 (list xdp (max yfp ysp)))
 (cond ((< xfp xdp) (setq fp2 (list (+ xdp 1.5) yfp)))
  ((> xfp xdp) (setq fp2 (list (- xdp 1.5) yfp)))
  (T nil))
 (if (/= yfp ysp) (progn
   (cond ((< xsp xdp) (setq sp2 (list (+ xdp 1.5) ysp)))
    ((> xsp xdp) (setq sp2 (list (- xdp 1.5) ysp)))
    (T nil))
   (cond ((<= ydp (cadr m1)) (setq u (* 1.5 pi)))
    ((>= ydp (cadr b1)) (setq u (/ pi 2)))
    ((< yfp ysp) (setq u (/ pi 2)))
    ((> yfp ysp) (setq u (* 1.5 pi)))
    (T nil))
   (initget 6)
   (setq scf (getreal "\n  <1>: "))
   (if (not scf) (setq scf 1.0))
   (setq po (getstring T
     "\n  (  ): "))
   (if (/= po "") (setq po (strcat " " po)))
;  (     )
   (setq dstr (/ (distance fp1 sp1) scf))
   (setq ok1 (rtos dstr 2 2))
   (if (/= "0" (substr ok1 (strlen ok1) 1))
    (setq ok ok1))
   (if (=  "0" (substr ok1 (strlen ok1) 1)) (progn
     (setq ok2 (substr ok1 1 (- (strlen ok1) 1)))
     (if (/= "0" (substr ok2 (strlen ok2) 1))
      (setq ok ok2))
     (if (=  "0" (substr ok2 (strlen ok2) 1)) (progn
       (setq ok3 (substr ok2 1 (- (strlen ok1) 3)))
       (setq ok ok3)))))
;                   
   (princ "\n  <")
   (princ (strcat ok po)) (princ "> :")
   (setq rt (getstring T))
   (if (= rt "") (setq rt (strcat ok po))))
  (progn (cond ((< yfp ydp) (setq u (/ pi 2)))
    ((> yfp ydp) (setq u (* 1.5 pi))) (T nil))
   (setq rt (getstring T "\n  <0> : "))
   (if (= rt "") (setq rt "0"))))
 (setq n 1 pr 0 sz 0)
 (repeat (strlen rt)
  (cond ((= (substr rt n 1) "%") (setq pr (1+ pr)))
   ((= (substr rt n 1) (chr 212)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 214)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 215)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 216)) (setq sz (1+ sz)))
   (T nil))
  (setq n (1+ n)))
 (setq drt (* (- (strlen rt) sz (* (/ pr 2) 5)) 2.5))
   (setq ytp (/ (+ yfp ysp) 2))
;                
 (if (/= yfp ysp) (progn (initget "1 2 3 4 Auto")
   (setq stre (getkword "\n   
 <-1->,  ->--<- 2,  <-->- 3,  ->-4-<-  <Auto>: "))
   (if (or (not stre) (= (strcase (substr stre 1 1)) "A"))
    (if (< (distance fp1 sp1) (+ drt 10))
     (if (< (distance fp1 sp1) (+ drt 1))
      (if (< (distance fp1 sp1) 11)
       (setq stre "2")
       (setq stre "3"))
      (setq stre "4"))
     (setq stre "1"))))
  (setq stre "2"))
;   ,    ,  
 (command "COLOR" "bylayer")
 (command "LAYER" "m" "dim" "c" 3 "dim" (command))
 (command "LINETYPE" "s" "bylayer" (command))
 (command "STYLE" "dim" "eskd" 3.5 0.9 15
  "n" "n" "n")
;         ,
;             
 (if (/= xfp xdp) (command "LINE" fp fp2 (command)))
 (if (and (/= xsp xdp) (/= yfp ysp))
  (command "LINE" sp sp2 (command)))
 (if (/= yfp ysp) (command "LINE" fp1 sp1 (command)))
 (if (or (= stre "4") (and (= stre "2") (= u (/ pi 2))))
  (command "LINE" m1 (polar m1 (* 1.5 pi) 8) (command)))
 (if (or (= stre "4") (and (= stre "2") (= u (* 1.5 pi))))
  (command "LINE" b1 (polar b1 (/ pi 2) 8) (command)))
 (if (or (= stre "1") (= stre "3")) (progn
   (command "PLINE" (polar m1 (/ pi 2) 4.5) "w" 1.3 0 m1
    (command))
   (command "PLINE" (polar b1 (* 1.5 pi) 4.5) "w" 1.3 0 b1
    (command))) (progn
   (command "PLINE" (polar m1 (* 1.5 pi) 4.5) "w" 1.3 0 m1
    (command))
   (command "PLINE" (polar b1 (/ pi 2) 4.5) "w" 1.3 0 b1
    (command))))
 (if (or (= stre "1") (= stre "4"))
  (command "TEXT" "c" (list (- xdp 2.0) ytp) 90 rt)
  (cond ((= u (* 1.5 pi)) (command "TEXT" "r"
     (list (- xdp 2.0) (- (cadr m1) 6)) 90 rt)
    (command "LINE" m1 (polar m1 (* 1.5 pi) (+ drt 6))
     (command)))
   ((= u (/ pi 2)) (command "TEXT"
     (list (- xdp 2.0) (+ (cadr b1) 6)) 90 rt)
    (command "LINE" b1 (polar b1 (/ pi 2) (+ drt 6))
     (command)))
   (T nil)))
 (rvars);       
 (setvar "OSMODE" osnap_def)
 (prin1))