;**********************************************************
;                      FORMAT.LSP
;                
;            , ,    
;----------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE") rgm (getvar "REGENMODE")
  osnap_def (getvar "OSMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 0)
 (setvar "HIGHLIGHT" 0) (setvar "REGENMODE" 0)
 (setvar "OSMODE" 0)
 (command "LINETYPE" "s" "bylayer" "")
 (command "MENULOAD" "FORMAT"))

;             
(defun rvars ()
 (MENUCMD "P1=-")
 (command "MENUUNLOAD" "FORMAT")
 (command "COLOR" clr)
 (command "LAYER" "s" lay "")
 (command "LINETYPE" "s" tln "")
 (command "ZOOM" "E")
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setvar "OSMODE" osnap_def)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))

;            
(defun fam (pf m fa)
 (command "TEXT" pf (* m 2.5) "0" fa))

;                  
(defun C:FORMAT (/ sed frmt nld ob na1 na2 na3 nad pp kld
 m1 m2 m3 mss msh zp raz prov tkon nsek nkon utv xf yf p1
 p2 p3 p4 mx my xna xfa ynad yna1 yna2 yna3 fzp dwgn
 clr lay tln osnap_def rgm oerr)

;                 
 (svars)

;                      
 (MENUCMD "P1=+FORMAT.FORMAT")
 (setq sed (getstring "\n\n   - <s>
  -  g
 .. -  m
      -  d: "))
 (princ sed)
 (if (= sed "") (setq sed "s"))
 (initget 7 "u1 u2 u3 u4")
 (setq frmt (getint "\n:
 -  <1, 2, 3, 4>
 -  <u1, u2, u3, u4>: "))
 (princ frmt)
 (initget 6)
 (if (/= sed "g")
  (setq nld (getint "\n   <1>: ")))
 (if (not nld) (setq nld 1))
 (princ nld)
 (cond ((or (= sed "g") (= sed "s") (= sed "m"))
   (setq ob (getstring
     "\n  : ")))
  ((= sed "d")
   (setq ob (getstring T "\n : ")))
  (T (setq ob (getstring T "\n: "))) )
 (if (and (= nld 1) (= sed "d")) (progn
   (setq na1 (getstring T
     "\n\n  1 - <[ 12 .]>: "))
   (setq na2 (getstring T
     "\n  2 - <[ 12 .]>: "))))
 (if (and (= nld 1)
   (or (= sed "g") (= sed "s") (= sed "m"))) (progn
   (setq na1 (getstring T "\n -  1 -
< 3-   -   16 .,
    3-  -   22 .>: "))
   (setq na2 (getstring T "\n             -  2 -
< 3-   -   16 .,
    3-  -   22 .>: "))
   (setq na3 (getstring T
"\n       -  3 - < 22 .>: "))))
 (cond ((and (= nld 1) (= sed "s"))
   (setq nad " "))
  ((and (= nld 1) (= sed "g"))
   (setq nad " "))
  ((and (= nld 1) (= sed "m"))
   (setq nad " "))
  (T nil))
 (if (and (= nld 1) (/= ob ""))
  (if (= sed "d")
   (setq pp (strcat (substr ob 1 (1- (strlen ob))) "0"))
   (setq pp ob)))
 (cond ((and (= sed "s") (/= ob ""))
   (setq ob (strcat ob " ")))
  ((and (= sed "g") (/= ob ""))
   (setq ob (strcat ob " ")))
  ((and (= sed "m") (/= ob ""))
   (setq ob (strcat ob " ")))
  (T nil))
 (initget 6)
 (if (and (= nld 1) (/= sed "g")) (progn
   (setq kld  (getint "\n.   <1>: "))))
 (if (and (= nld 1) (not kld)) (setq kld 1))
 (princ kld)
 (if (and (= nld 1) (= sed "d")) (progn
   (MENUCMD "P1=FORMAT.MATERIAL")
   (setq m1 (getstring T
     "\n\n  1 - <[ 26 .]>: "))
   (princ m1)
   (setq m2 (getstring T
     "\n\n  2 - <[ 26 .]>: "))
   (princ m2)
   (setq m3 (getstring T
     "\n\n  3 - <[ 26 .]>: "))
   (princ m3)))
 (if (= nld 1) (progn
   (MENUCMD "P1=FORMAT.FORMAT")
   (setq mss  (getstring "\n: "))
   (setq msh  (getstring "\n.: "))
   (princ msh)
   (setq zp (getstring "\n 
   -   - 0,
   -       - 1,
   -       - 2: "))
   (princ zp)
   (if (= zp "") (setq zp "0"))
   (setq raz  (getstring "\n.  <[]>: "))
   (princ raz)
   (setq prov (getstring "\n.    <[]>: "))
   (princ prov)
   (setq tkon (getstring "\n.. <[]>: "))
   (princ tkon)
   (setq nsek (getstring "\n..<[]>: "))
   (princ nsek)
   (setq nkon (getstring "\n.. <[]>: "))
   (princ nkon)
   (setq utv  (getstring "\n.     <[]>: "))
   (princ utv)))

;                     
 (cond ((= frmt 1) (setq xf 841 yf 594))
  ((= frmt 2) (setq xf 594 yf 420))
  ((= frmt 3) (setq xf 420 yf 297))
  ((= frmt 4) (setq xf 210 yf 297))
  ((= frmt "u1") (setq xf 815 yf 580))
  ((= frmt "u2") (setq xf 565 yf 400))
  ((= frmt "u3") (setq xf 385 yf 275))
  ((= frmt "u4") (setq xf 185 yf 260))
  (T nil))
 (setq p1 '(20 5) p2 (list (- xf 5) 5)
  p3 (list (- xf 5) (- yf 5)) p4 (list 20 (- yf 5)))
 (if (= frmt "u4") (setq mx (/ (- xf 25) 185.0))
  (setq mx 1.0))
 (if (or (= frmt "u3") (= frmt "u4"))
  (setq my (/ (- yf 10) 287.0))
  (setq my 1.0))
 (if (= nld 1)
  (setq xna (- xf 5 (* mx 85)) xfa (- xf 5 (* mx 167))))
 (cond ((and (= nld 1) (/= sed "d") (/= na3 ""))
   (setq yna1 41.5 yna2 35.5 yna3 29.5 ynad 23.5))
  ((and (= nld 1) (/= sed "d") (/= na2 ""))
   (setq yna1 39.5 yna2 32.5 ynad 25.5))
  ((and (= nld 1) (/= sed "d") (/= na1 ""))
   (setq yna1 37.5 ynad 27.5))
  ((and (= nld 1) (= sed "d") (/= na2 ""))
   (setq yna1 37.5 yna2 27.5))
  ((and (= nld 1) (= sed "d") (/= na1 ""))
   (setq yna1 32.5))
  (T nil))
 (cond ((= zp "1") (setq fzp "znp"))
  ((= zp "2") (setq fzp "zkbm"))
  (T nil))
;          
 (if (= (type frmt) 'INT)
  (command "LAYER" "m" "fo" "")
  (command "LAYER" "m" "fu" ""))
 (command "LIMITS" '(0 0) (list xf yf) "ZOOM" "a")
 (command "COLOR" "bylayer")
 (command "INSERT" "nl" p1 "1" my "0")
 (if (= nld 1) (progn
   (command "INSERT" "on" p2 mx "1" "0")
   (command "LINE"
    (polar p4 (* 1.5 pi) 14) "@137,0" "@0,14" "")
   (command "COPY" "l" "" "m" "@" "@-67,0" "@-53,0" "")
   (command "LINE"
    (polar (polar p4 0 84) (* 1.5 pi) 7) "@53,0" "")
   (command "INSERT" "snpp" p1 "1" my "0")
   (if (or (= zp "1") (= zp "2"))
    (command "INSERT"  (strcat "" fzp)
     (list (- xf 5 (* mx 25)) 12.5) "1" "1" "0")))
  (progn
   (command "INSERT" "ont2" p2 mx "1" "0")
   (command "LINE"
    (polar p4 (* 1.5 pi) 14) "@70,0" "@0,14" "")))
 (cond ((and (= nld 1)
    (or (= frmt 3) (= frmt 4) (= frmt "u3") (= frmt "u4")))
   (command "INSERT"
    "pb1" (list 8 (- yf 5)) "1" my "0"))
  ((and (= nld 1)
   (or (= frmt 1) (= frmt 2) (= frmt "u1") (= frmt "u2")))
   (command "INSERT"
    "pb2" '(8 292) "1" "1" "0"))
  (T nil))
 (cond ((and (= nld 1) (or (= frmt 4) (= frmt "u4")))
   (command "LINE" p1 p2 p3 p4 '(20 60) ""))
  ((and (> nld 1) (= frmt 4) (= frmt "u4"))
   (command "LINE" p1 p2 p3 p4 '(20 20) ""))
  (T (command "LINE" p1 p2 p3 p4 "c")))
 (command "STYLE"
  "eskd" "eskd" "0" "0.9" "15" "n" "n" "n")
 (cond ((and (= nld 1) (/= ob "")) (command "TEXT"
    "m" (list (- xf 5 (* mx 60)) 52.5) (* mx 7) "0" ob))
  ((and (/= nld 1) (/= ob "")) (command "TEXT"
    "m" (list (- xf 5 (* mx 65)) 12.5) (* mx 7) "0" ob))
  (T nil))
 (if (and (= nld 1) (= sed "d") (/= na1 ""))
  (command "TEXT" "m" (list xna yna1) (* mx 7) "0" na1))
 (if (and (= nld 1) (= sed "d") (/= na2 ""))
  (command "TEXT" "m" (list xna yna2) (* mx 7) "0" na2))
 (command "COLOR" "4")
 (if (and (= nld 1) (/= sed "d") (/= na1 "") (= na3 ""))
  (command "TEXT" "m" (list xna yna1) (* mx 5) "0" na1))
 (if (and (= nld 1) (/= sed "d") (/= na2 "") (= na3 ""))
  (command "TEXT" "m" (list xna yna2) (* mx 5) "0" na2))
 (if (and (= nld 1) (/= sed "d") (/= sed "m")
   (/= na1 "") (= na3 ""))
  (command "TEXT" "m" (list xna ynad) (* mx 5) "0" nad))
 (if (/= ob "")
  (command "TEXT" "m" (list 55 (- yf 12)) "5" "180" ob))
 (command "COLOR" "3")
 (command "LINE"
  '(0 0) (list xf 0) (list xf yf) (list 0 yf) "c")
 (if (and (= nld 1) (/= ob ""))
  (command "TEXT"
   "m" (list 16.5 (+ 5 (* my 257))) (* my 3.5) "90" pp))
 (if (= nld 1) (command "TEXT"
   (list (- xf 5 (* mx 7.0)) 21.5) "2.5" "0" (itoa kld)))
 (if (and (= nld 1) (> kld 1)) (command "TEXT"
   (list (- xf 5 (* mx 34.0)) 21.5) "2.5" "0" "1"))
 (if (> nld 1)  (command "TEXT" "m"
   (list (- xf 5 (* mx 5.0)) 9) (* mx 3.5) "0" (itoa nld)))
 (if (and (= nld 1) (/= sed "d") (/= na1 "") (/= na3 ""))
  (command "TEXT" "m" (list xna yna1) (* mx 3.5) "0" na1))
 (if (and (= nld 1) (/= sed "d") (/= na2 "") (/= na3 ""))
  (command "TEXT" "m" (list xna yna2) (* mx 3.5) "0" na2))
 (if (and (= nld 1) (/= sed "d") (/= na3 "")) (progn
   (command "TEXT" "m" (list xna yna3) (* mx 3.5) "0" na3)
   (command "TEXT" "m" (list xna ynad) (* mx 3.5)
    "0" nad)))
 (if (and (= nld 1) (= sed "m") (/= na1 ""))
  (command "TEXT" "m" (list xna ynad) (* mx 3.5) "0" nad))
 (if (and (= nld 1) (/= mss "")) (command "TEXT" "m"
   (list (- xf 5 (* mx 26.5)) 32.5) (* mx 3.5) "0" mss))
 (if (and (= nld 1) (/= msh "")) (command "TEXT" "m"
   (list  (- xf 5 (* mx 9.0)) 32.5)  (* mx 3.5) "0" msh))
 (if (and (= nld 1) (/= m1 "") (/= m2 "") (/= m3 ""))
  (progn
   (command "TEXT" "m" (list xna 17.5) (* mx 2.5) "0" m1)
   (command "TEXT" "m" (list xna 12.5) (* mx 2.5) "0" m2)
   (command "TEXT" "m" (list xna  7.5) (* mx 2.5) "0" m3)))
 (if (and (= nld 1) (/= m1 "") (/= m2 "") (= m3 "")) (progn
   (command "TEXT" "m" (list xna 15) (* mx 3.5) "0" m1)
   (command "TEXT" "m" (list xna 10) (* mx 3.5) "0" m2)))
 (if (and (= nld 1) (/= m1 "") (= m2 "") (= m3 ""))
  (command "TEXT" "m" (list xna 12.5) (* mx 3.5) "0" m1))
 (if (= (type frmt) 'INT)
  (setq frmt (itoa frmt)) (progn
   (command "TEXT" (list (- xf 4) 1.5) "2.5" "0" "")
   (setq frmt (substr frmt 2))))
 (command "TEXT" (list (- xf 5 (* mx 30.0)) 1.5) "2.5" "0"
  (strcat "" frmt))
 (if (and (= nld 1) (/= raz ""))
  (fam (list xfa 31.5) mx raz))
 (if (and (= nld 1) (/= prov ""))
  (fam (list xfa 26.5) mx prov))
 (if (and (= nld 1) (/= tkon ""))
  (fam (list xfa 21.5) mx tkon))
 (if (and (= nld 1) (/= nsek ""))
  (fam (list xfa 16.5) mx nsek))
 (if (and (= nld 1) (/= nkon ""))
  (fam (list xfa 11.5) mx nkon))
 (if (and (= nld 1) (/= utv ""))
  (fam (list xfa  6.5) mx utv))
 (if (= (getvar "DWGPREFIX") (substr (getvar "DWGNAME")
    1 (strlen (getvar "DWGPREFIX"))))
  (setq dwgn (substr (getvar "DWGNAME")
   (1+ (strlen (getvar "DWGPREFIX")))))
  (setq dwgn (getvar "DWGNAME")))
 (command "TEXT" (list (- xf 1.5) 45) "2.5" "90" dwgn)
;             
 (rvars)
 (prin1))