;**********************************************************
;                        GRF.LSP
;               
;----------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE") osnap_def (getvar "OSMODE")
  rgm (getvar "REGENMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 0)
 (setvar "HIGHLIGHT" 0) (setvar "REGENMODE" 0)
 (command "LAYER" "s" "0" "")
 (command "STYLE" "eskd" "eskd"
  "0" "0.9" "15" "n" "n" "n")
 (command "LINETYPE" "s" "bylayer" "")
 (command "MENULOAD" "FORMAT"))


;             
(defun rvars ()
 (command "COLOR" clr)
 (command "LAYER" "s" lay "")
 (command "LINETYPE" "s" tln "")
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setvar "OSMODE" osnap_def)
 (MENUCMD "P1=-")
 (command "MENUUNLOAD" "FORMAT")
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))
;                  
(defun C:GRF (/ xf yf pz mx my nl xpz ypz h u te lr osnap_def)
 (svars);         

;                      
 (MENUCMD "P1=+FORMAT.FORMAT")
 (setq xf (car (getvar "LIMMAX"))
  yf (cadr (getvar "LIMMAX")) pz '(0 0))
 (if (< xf 210.0)
  (setq mx (/ (- xf 25) 185.0)) (setq mx 1.0))
 (if (< yf 297.0)
  (setq my (/ (- yf 10) 287.0)) (setq my 1.0))
 (initget 6)
 (setq nl (getint "\n   <1>: "))
 (if (not nl) (setq nl 1) (if (> nl 2) (setq nl 2)))
 (while pz (setq pz (getpoint
    "\n     : "))
  (if pz (progn (setq xpz (car pz) ypz (cadr pz))
    (cond ((< 13 xpz 20) (setq prt "m" u 90)
      (command "COLOR" "3")
      (cond ((< 5 ypz (+ 5 (* my 145.0)))
        (setq h (* my 2.5)))
       ((< (+ 5 (* my 167.0)) ypz (+ 5 (* my 287.0)))
        (setq h (* my 3.5)))
       (T nil))
      (cond ((< 5 ypz (+ 5 (* my 25.0)))
        (setq pt (list 16.5 (+ 5 (* my 12.5)))
         te (getstring "\n.N .: ")))
       ((< (+ 5 (* my 25.0)) ypz (+ 5 (* my 60.0)))
        (setq pt (list 16.5 (+ 5 (* my 42.5))) te (strcat
          "(.) " (getstring "\n .: "))))
       ((< (+ 5 (* my 60.0)) ypz (+ 5 (* my 85.0)))
        (setq pt (list 16.5 (+ 5 (* my 72.5)))
         te (getstring "\n..N: ")))
       ((< (+ 5 (* my 85.0)) ypz (+ 5 (* my 110.0)))
        (setq pt (list 16.5 (+ 5 (* my 97.5)))
         te (getstring "\n.N .: ")))
       ((< (+ 5 (* my 110.0)) ypz (+ 5 (* my 145.0)))
        (setq pt (list 16.5 (+ 5 (* my 127.5))) te (strcat
          "(.) " (getstring "\n .: "))))
       ((and (< (+ 5 (* my 167.0)) ypz (+ 5 (* my 227.0)))
         (= nl 1))
        (setq pt (list 16.5 (+ 5 (* my 197.0)))
         te (getstring "\n. N: ")))
       ((and (< (+ 5 (* my 227.0)) ypz (+ 5 (* my 287.0)))
         (= nl 1))
        (setq pt (list 16.5 (+ 5 (* my 257.0)))
         te (getstring "\n. .: ")))
       (T nil)))
     ((and (< 0 xpz 8) (< 5 ypz 110))
      (command "COLOR" "3")
      (setq prt "l" h (* my 3.0) u 90 pt '(6.0 6.0)
       te "  . :"))
     ((< (- yf 5) ypz yf)
      (command "COLOR" "3")
      (setq np (getstring
        "\n   <1>: "))
      (if (= np "") (setq np "1"))
      (setq prt "r" h 3.0 u 0 pt (list (- xf 20) (- yf 4))
       te (strcat "  N%%d: " np)))
     ((and (= nl 1) (< 104 xpz 157)
       (< (- yf 19) ypz (- yf 5)))
      (command "COLOR" "3")
      (setq prt "m" h 3.5 u 180 pt (list 130.5 (- yf 8.5))
       te (getstring T "\nN : ")))
     ((and (< (- xf 5 (* mx 185)) xpz (- xf 5 (* mx 130)))
       (or (and (< 40 ypz 45) (= nl 1))
        (and (< 10 ypz 15) (= nl 2))))
      (command "COLOR" "3")
      (setq prt "m" h (* mx 2.0) u 0) (cond
       ((< (- xf 5 (* mx 185)) xpz (- xf 5 (* mx 178)))
        (if (= nl 1)
         (setq pt (list (- xf 5 (* mx 181.5)) 42.5))
         (setq pt (list (- xf 5 (* mx 181.5)) 12.5)))
        (setq te (getstring "\n.: ")))
       ((< (- xf 5 (* mx 178)) xpz (- xf 5 (* mx 168)))
        (if (= nl 1)
         (setq pt (list (- xf 5 (* mx 173.0)) 42.5))
         (setq pt (list (- xf 5 (* mx 173.0)) 12.5)))
        (setq te (getstring "\n: ")))
       ((< (- xf 5 (* mx 168)) xpz (- xf 5 (* mx 145)))
        (if (= nl 1)
         (setq pt (list (- xf 5 (* mx 156.5)) 42.5))
         (setq pt (list (- xf 5 (* mx 156.5)) 12.5)))
        (setq te (getstring "\nN .: ")))
       ((< (- xf 5 (* mx 145)) xpz (- xf 5 (* mx 130)))
        (if (= nl 1)
         (setq pt (list (- xf 5 (* mx 137.5)) 42.5))
         (setq pt (list (- xf 5 (* mx 137.5)) 12.5)))
        (setq te "(.)"))
       (T nil)))
     ((and (< (- xf 5 (* mx 130)) xpz (- xf 5 (* mx 120)))
       (< 5 ypz 45)) (setq prt "m" h (* mx 1.7) u 0)
      (command "COLOR" "3")
      (cond ((or
         (and (< 40 ypz 45) (= nl 1))
         (and (< 10 ypz 15) (= nl 2)))
        (setq te (getstring "\n .: "))
        (if (= nl 1)
         (setq pt (list (- xf 5 (* mx 125)) 42.5))
         (setq pt (list (- xf 5 (* mx 125)) 12.5))))
       ((and (< 30 ypz 35) (= nl 1))
        (setq pt (list (- xf 5 (* mx 125)) 32.5)
         te (getstring "\n .: ")))
       ((and (< 25 ypz 30) (= nl 1))
        (setq pt (list (- xf 5 (* mx 125)) 27.5)
         te (getstring "\n .: ")))
       ((and (< 20 ypz 25) (= nl 1))
        (setq pt (list (- xf 5 (* mx 125)) 22.5)
         te (getstring "\n ..: ")))
       ((and (< 15 ypz 20) (= nl 1))
        (setq pt (list (- xf 5 (* mx 125)) 17.5)
         te (getstring "\n ..: ")))
       ((and (< 10 ypz 15) (= nl 1))
        (setq pt (list (- xf 5 (* mx 125)) 12.5)
         te (getstring "\n ..: ")))
       ((and (< 5 ypz 10) (= nl 1))
        (setq pt (list (- xf 5 (* mx 125)) 7.5)
         te (getstring "\n .: ")))
       (T nil)))
     ((and (< (- xf 5 (* mx 145)) xpz (- xf 5 (* mx 130)))
       (< 5 ypz 35) (= nl 1))
      (command "COLOR" "3")
      (setq prt "m" h (* mx 2.0) u 0 te "(.)")
      (cond ((< 30 ypz 35)
        (setq pt (list (- xf 5 (* mx 137.5)) 32.5)))
       ((< 25 ypz 30)
        (setq pt (list (- xf 5 (* mx 137.5)) 27.5)))
       ((< 20 ypz 25)
        (setq pt (list (- xf 5 (* mx 137.5)) 22.5)))
       ((< 15 ypz 20)
        (setq pt (list (- xf 5 (* mx 137.5)) 17.5)))
       ((< 10 ypz 15)
        (setq pt (list (- xf 5 (* mx 137.5)) 12.5)))
       ((< 5 ypz 10)
        (setq pt (list (- xf 5 (* mx 137.5)) 7.5)))
       (T nil)))
     ((and (< (- xf 5 (* mx 50)) xpz (- xf 5))
       (< 25 ypz 40) (= nl 1))
      (command "COLOR" "3")
      (setq prt "m" h (* mx 3.0) u 0)
      (cond ((< (- xf 5 (* mx 50)) xpz (- xf 5 (* mx 45)))
        (setq pt (list (- xf 5 (* mx 47.5)) 32.5)
         te (getstring "\n <>: "))
        (if (= te "") (setq te "")))
       ((< (- xf 5 (* mx 45)) xpz (- xf 5 (* mx 40)))
        (setq pt (list (- xf 5 (* mx 42.5)) 32.5)
         te (getstring "\n <%%2141%%215>: "))
        (if (= te "") (setq te "%%2141%%215")))
       ((< (- xf 5 (* mx 40)) xpz (- xf 5 (* mx 35)))
        (setq pt (list (- xf 5 (* mx 37.5)) 32.5)
         te (getstring "\n <>: "))
        (if (= te "") (setq te "")))
       ((< (- xf 5 (* mx 35)) xpz (- xf 5 (* mx 18)))
        (setq pt (list (- xf 5 (* mx 26.5)) 32.5)
         te (getstring "\n: ")))
       ((< (- xf 5 (* mx 18)) xpz (- xf 5))
        (setq pt (list (- xf 5 (* mx 9)) 32.5)
         te (getstring "\n: ")))
       (T nil)))
     ((and (< (- xf 5 (* mx 120)) xpz (- xf 5))
       (< 60 ypz 68) (= nl 1))
      (command "COLOR" "bylayer")
      (setq prt "m" h (* mx 5.0) u 0
       pt (list (- xf 5 (* mx 60)) 64)
       te (getstring "\n: ")))
     ((or (and (< (- xf 5 (* mx 120)) xpz (- xf 5))
        (< 45 ypz 60) (= nl 1))
       (and (< (- xf 5 (* mx 120)) xpz (- xf 5 (* mx 10)))
        (< 5 ypz 20) (= nl 2)))
      (command "COLOR" "bylayer")
      (setq prt "m" h (* mx 7.0) u 0
       te (getstring T "\n : "))
      (if (= nl 1)
       (setq pt (list (- xf 5 (* mx 60)) 52.5))
       (setq pt (list (- xf 5 (* mx 65)) 12.5))))
     ((and (< 20 xpz 90) (< (- yf 19) ypz (- yf 5)))
      (command "COLOR" "bylayer")
      (setq prt "m" h 5.0 u 180 pt (list 55 (- yf 12))
         te (getstring T "\n : ")))
     ((or (and (< (- xf 5 (* mx 50)) xpz
        (- xf 5 (* mx 30))) (< 20 ypz 25)
         (= nl 1))
       (and (< (- xf 5 (* mx 10)) xpz (- xf 5))
        (< 5 ypz 13) (= nl 2)))
      (setq u 0 te (getstring "\n: "))
      (command "COLOR" "3")
      (if (= nl 1)
       (progn (setq prt "l" h 2.5
         pt (list (- xf 5 (* mx 35)) 21.5)))
       (progn (setq prt "m" h (* mx 3.5)
         pt (list (- xf 5 (* mx 5)) 9.0)))))
     ((and (< (- xf 5 (* mx 30)) xpz (- xf 5))
       (< 20 ypz 25) (= nl 1))
      (command "COLOR" "3")
      (setq prt "l" h 2.5
       pt (list (- xf 5 (* mx 9)) 21.5)
       te (getstring "\n: ")))
     ((and (< (- xf 5 (* mx 168)) xpz (- xf 5 (* mx 145)))
       (< 5 ypz 35) (= nl 1))
      (command "COLOR" "3")
      (setq prt "l" h (* mx 2.5) u 0)
      (cond ((< 30 ypz 35)
        (setq pt (list (- xf 5 (* mx 166.5)) 31.5)
         te (getstring "\n.  <[]>: "))
        (princ te) (command "TEXT" pt h u te)
        (while (and (/= read-char 10) (/= read-char 32))
         (setq pt (polar pt (* 1.5 pi) 5)
          te (getstring)) (princ te)
         (command "TEXT" pt h u te))
        (setq te ""))
       ((< 25 ypz 30)
        (setq pt (list (- xf 5 (* mx 166.5)) 26.5)
         te (getstring "\n.    <[]>: "))
        (princ te))
       ((< 20 ypz 25)
        (setq pt (list (- xf 5 (* mx 166.5)) 21.5)
         te (getstring "\n.. <[]>: "))
        (princ te))
       ((< 15 ypz 20)
        (setq pt (list (- xf 5 (* mx 166.5)) 16.5)
         te (getstring "\n..<[]>: "))
        (princ te))
       ((< 10 ypz 15)
        (setq pt (list (- xf 5 (* mx 166.5)) 11.5)
         te (getstring "\n.. <[]>: "))
        (princ te))
       ((< 5 ypz 10)
        (setq pt (list (- xf 5 (* mx 166.5)) 6.5)
         te (getstring "\n.     <[]>: "))
        (princ te))
       (T nil)))
     ((and (< (- xf 5 (* mx 120)) xpz (- xf 5 (* mx 50)))
       (< 5 ypz 20) (= nl 1))
      (command "COLOR" "3")
      (setq prt "m" h (* mx 3.5) u 0
       pt (list (- xf 5 (* mx 85)) 17.5) te (getstring T
        "\n - ( 26 .  ): "))
      (while (/= read-char 10)
       (setq pt (polar pt (* 1.5 pi) 5)
        te (getstring T)) (princ te)
       (command "TEXT" pt h u te))
      (setq te ""))
     ((and (< (- xf 5 (* mx 50)) xpz (- xf 5))
        (< 5 ypz 20) (= nl 1))
      (command "COLOR" "3")
      (princ "\n :")
      (princ "\n-    - 1,")
      (princ "\n-    - <>: ")
      (setq te (getstring T)
       pt (list (- xf 5 (* mx 25)) 12.5))
      (if (= te "1")
       (progn (princ te)
        (setq lr '(3.75 4.7 5.0 5.3) te "")
        (foreach r lr (command "CIRCLE" pt r))
        (command "PLINE" (polar pt pi 2.5) "w" 5 5
         (polar pt 0 2.5) ""))
       (setq prl "m" h (* mx 3.5) u 0)))
     (T (prompt "\n     .")
      (setq te "")))
;                 
    (if (/= te "") (if (/= prt "l")
      (command "TEXT" prt pt h u te)
      (command "TEXT" pt h u te))))))
;             
 (rvars)
 (prin1))