;**********************************************************
;                        IPT.LSP
;                 
;----------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE") rgm (getvar "REGENMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "HIGHLIGHT" 1)
 (setvar "REGENMODE" 0))

;             
(defun rvars ()
 (command "COLOR" clr)
 (command "LAYER" "s" lay "")
 (command "LINETYPE" "s" tln (command))
 (setvar "CMDECHO" 1) (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))
;                    
(defun C:IPT (/ st n k ldl tv ktv dl p1 p2 h u kv l
  stl col la tl dst clr lay tln rgm oerr)
 (svars);          

 (setq st (ssget) n (sslength st) k 0 ldl '())
 (initget 1 "L l C c M m A a F f R r")
 (setq tv (strcase (getkword "\n  -
 L  !____\n C  __!__\n M  --+--
 A  .____.\n F  !____!\n R  ____! : ")))
 (cond ((= tv "L") (setq ktv 0))
  ((= tv "C") (setq ktv 1))
  ((= tv "M") (setq ktv 4))
  ((= tv "A") (setq ktv 3))
  ((= tv "F") (setq ktv 5))
  ((= tv "R") (setq ktv 2))
  (T nil))
 (while (< k n)
  (setq dl (entget (ssname st k)))
  (if (= (cdr (assoc 0 dl)) "TEXT")
   (setq ldl (cons dl ldl)))
  (setq k (1+ k)))
 (setq n (length ldl))
 (foreach %d ldl
  (setq p1 (cdr (assoc 10 %d)) p2 (cdr (assoc 11 %d))
   h (cdr (assoc 40 %d)) u (cdr (assoc 50 %d))
   kv (cdr (assoc 72 %d)))
  (if (= kv 0) (if (/= ktv 0) (progn
     (setq l (cdr (assoc 1 %d)) stl (cdr (assoc 7 %d))
      col (cdr (assoc 62 %d)) la (cdr (assoc 8 %d))
      tl (cdr (assoc 6 %d)) dst (tblsearch "STYLE" stl))
     (if (or (not col) (= col 0))
      (setq col "bylayer")
      (setq col (itoa col)))
     (if (not tl) (setq tl "bylayer"))
     (command "COLOR" col)
     (command "LAYER" "s" la "")
     (command "LINETYPE" "s" tl (command))
     (if (/= (cdr (assoc 40 dst)) h)
      (command "STYLE" stl "" h "" "" "n" "n" "n"))
     (command "SELECT" (cdr (assoc -1 %d)))
     (cond ((= ktv 1) (initget 1)
       (setq p2 (getpoint "\n : ")))
      ((= ktv 4) (initget 1)
       (setq p2 (getpoint "\n : ")))
      ((or (= ktv 2) (= ktv 3) (= ktv 5)) (initget 1)
       (setq p2 (getpoint "\n : ")))
      (T nil))
     (command)
     (cond ((or (= ktv 1) (= ktv 2) (= ktv 4))
       (command "TEXT" tv p2 (angtos u) l))
      ((or (= ktv 3) (= ktv 5))
       (command "TEXT" tv p1 p2 l))
      (T nil))
     (entdel (cdr (assoc -1 %d)))))
   (if (/= kv ktv) (progn (setq dl
      (entmod (subst (cons 72 ktv) (assoc 72 %d) %d)))
     (cond ((= ktv 0) (if (= (getvar "FLATLAND") 1)
        (setq p2 '(0.0 0.0)) (setq p2 '(0.0 0.0 0.0))))
      ((and (= kv 1) (= ktv 4))
       (setq p2 (polar p2 (+ u (/ pi 2)) (/ h 2))))
      ((and (= kv 1) (or (= ktv 2) (= ktv 3) (= ktv 5)))
       (setq p2 (polar p2 u (distance p1 p2))))
      ((and (= kv 4) (= ktv 1))
       (setq p2 (polar p2 (- u (/ pi 2)) (/ h 2))))
      ((and (= kv 4) (or (= ktv 2) (= ktv 3) (= ktv 5)))
       (setq p2 (polar (polar p2 (- u (/ pi 2)) (/ h 2))
         u (distance p1 p2))))
      ((and (or (= kv 2) (= kv 3) (= kv 5)) (= ktv 1))
       (setq p2 (polar p1 u (/ (distance p1 p2) 2))))
      ((and (or (= kv 2) (= kv 3) (= kv 5)) (= ktv 4))
       (setq p2 (polar (polar p1 u (/ (distance p1 p2) 2))
         (+ u (/ pi 2)) (/ h 2))))
      (T nil))
     (entmod (subst (cons 11 p2) (assoc 11 dl) dl))))))
 (rvars);         
 (prin1))