;**********************************************************
;                       ISHT.LSP
;                   
;----------------------------------------------------------
;               
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq rgm (getvar "REGENMODE"))
 (setvar "BLIPMODE" 0) (setvar "CMDECHO" 0)
 (setvar "REGENMODE" 0)
 (setq osnap_def (getvar "OSMODE")) 
 (setvar "OSMODE" 0))
;             
(defun rvars ()
 (setvar "BLIPMODE" 1) (setvar "CMDECHO" 1)
 (setvar "REGENMODE" rgm)
 (setvar "OSMODE" osnap_def)
 (setq *error* oerr))

;            
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))
;              
(defun scroll (l)
 (append (cdr l) (list (car l))))

;                  
(defun C:ISHT
 (/ st n k ldl lp1 ly lr sh dl p1 u y p0 p rgm oerr osnap_def)
 (svars);          

 (setq st (ssget) n (sslength st) k 0 ldl '() lp1 '()
  ly '() lr '())
 (initget 6)
 (setq sh (getdist "\n   <12>: "))
 (if (not sh) (setq sh 12.0))
 (while (< k n)
  (setq dl (entget (ssname st k)))
  (if (= (cdr (assoc 0 dl)) "TEXT")
   (setq p1 (cdr (assoc 10 dl)) ldl (cons dl ldl)
    lp1 (cons p1 lp1)))
  (setq k (1+ k)))
 (setq u (cdr (assoc 50 (car ldl))) n (length ldl))
 (foreach %p lp1
  (setq y (- (* (cadr %p) (cos u)) (* (car %p) (sin u)))
   ly (cons y ly)))
 (setq ly (reverse ly))
 (repeat n
  (while (/= (car ly) (apply 'max ly))
   (setq ly (scroll ly) ldl (scroll ldl)))
  (setq lr (cons (car ldl) lr) ldl (cdr ldl) ly (cdr ly)))
 (if (= (cdr (assoc 72 (last lr))) 0)
  (setq p0 (cdr (assoc 10 (last lr))))
  (setq p0 (cdr (assoc 11 (last lr)))))
 (foreach %d lr
  (if (= (cdr (assoc 72 %d)) 0)
   (setq p (cdr (assoc 10 %d)))
   (setq p (cdr (assoc 11 %d))))
  (command "MOVE" (cdr (assoc -1 %d)) "" p
   (polar p0 (- u (/ pi 2)) (* (1- n) sh)))
  (setq n (1- n)))
 (rvars);         
 (prin1))