;**********************************************************
;                       PL.LSP
;                   
;----------------------------------------------------------
;                 
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") tln (getvar "CELTYPE")
  tst (getvar "TEXTSTYLE") rgm (getvar "REGENMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 0)
 (setvar "HIGHLIGHT" 0) (setvar "REGENMODE" 0)
 (command "COLOR" "3")
 (command "LINETYPE" "s" "bylayer" (command))
 (command "STYLE" "eskd" "eskd" 0 0.9 15
  "n" "n" "n"))

;           
(defun rvars ()
 (command "COLOR" clr) tst (getvar "TEXTSTYLE")
 (command "LINETYPE" "s" tln (command))
 (command "TEXT" "s" tst (command))
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;          
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\nProgram aborted"))
 (rvars)
 (princ))
;                  
(defun C:PL (/ sh sc nx ny p0 p1 px py n osnap_def)
 (svars)
;                    
 (initget 6)
 (setq sh (getreal "\n   <1.27>: "))
 (if (not sh) (setq sh 1.27))
 (initget 6)
 (setq sc (getreal "\n  <2>: "))
 (if (not sc) (setq sc 2.0))
 (setvar "BLIPMODE" 1)
 (setq p0 (getpoint "\n  0,0: "))
 (setq p1 (getpoint "\n   : "))
 (setvar "BLIPMODE" 0)
 (setq osnap_def (getvar "OSMODE")) 
 (setvar "OSMODE" 0)
 (setq nx (/ (- (car p1) (car p0)) (* sc sh))
       ny (/ (- (cadr p1) (cadr p0)) (* sc sh)))

 (cond ((and (> nx 0) (> ny 0))
   (setq angx (* 1.5 pi) angy pi angmx 0 angmy (/ pi 2)))
  ((and (< nx 0) (> ny 0))
   (setq angx (* 1.5 pi) angy 0 angmx pi angmy (/ pi 2)))
  ((and (< nx 0) (< ny 0))
   (setq angx (/ pi 2) angy 0 angmx pi angmy (* 1.5 pi)))
  ((and (> nx 0) (< ny 0))
   (setq angx (/ pi 2) angy pi angmx 0 angmy (* 1.5 pi))))

 (setq nx (abs nx) ny (abs ny))
 (setq py (polar p0 angy 2) px (polar p0 angx 2))
 (setq n 0)
 (while (< n ny)  
  (command "LINE" py (polar py angy 4) (command))
  (command "TEXT" "m" (polar py angy 9) 3.5 0 (itoa n))
  (setq py (polar py angmy (* sc sh)))
  (repeat 4 (command "LINE" py (polar py angy 3) (command))
  (setq py (polar py angmy (* sc sh))))
  (setq n (+ n 5)))
  (command "LINE" py (polar py angy 4) (command))
  (command "TEXT" "m" (polar py angy 9) 3.5 0 (itoa n))
 (setq n 0)
 (while (< n nx)  
  (command "LINE" px (polar px angx 4) (command))
  (command "TEXT" "m" (polar px angx 9) 3.5 0 (itoa n))
  (setq px (polar px angmx (* sc sh)))
  (repeat 4 (command "LINE" px (polar px angx 3) (command))
  (setq px (polar px angmx (* sc sh))))
  (setq n (+ n 5)))
  (command "LINE" px (polar px angx 4) (command))
  (command "TEXT" "m" (polar px angx 9) 3.5 0 (itoa n))
 (command "COLOR" "bylayer")
 (rvars)
 (setvar "OSMODE" osnap_def)
 (prin1))