;**********************************************************
;                       RAD.LSP
;                    
;----------------------------------------------------------
;             
(defun svars ()
 (setq oerr *error* *error* erro)
 (setq clr (getvar "CECOLOR") lay (getvar "CLAYER")
  tln (getvar "CELTYPE") tst (getvar "TEXTSTYLE")
  rgm (getvar "REGENMODE"))
 (if (/= (substr clr 1 2) "BY")
  (setq clr (substr clr 1 1)))
 (setvar "CMDECHO" 0) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" 0))

;           
(defun rvars ()
 (command "COLOR" clr)
 (command "LAYER" "s" lay (command))
 (command "LINETYPE" "s" tln (command))
 (command "TEXT" "s" tst (command))
 (setvar "CMDECHO" 1) (setvar "BLIPMODE" 1)
 (setvar "HIGHLIGHT" 1) (setvar "REGENMODE" rgm)
 (setq *error* oerr))

;          
(defun erro (msg)
 (if (= msg "Function cancelled")
  (princ "\n  "))
 (rvars)
 (princ))

;,    
;        
(defun usl (k n u)
 (or (and (> k n) (> k u) (> u n))
  (and (< k n) (or (< u k) (> u n)))))
(defun us1 () (usl uk un ug))
(defun us2 () (and (usl un uk ug) (usl unr uk ug)
  (or (and (> uk un) (< (- uk un) pi))
   (and (< uk un) (> (- un uk) pi)))))
(defun us3 () (and (usl un uk ug) (usl ukr unr ug)))
(defun us4 () (and (usl un uk ug) (usl un ukr ug)
  (or (and (> uk un) (< (- uk un) pi))
   (and (< uk un) (> (- un uk) pi)))))
(defun us5 ()
 (or (> ug (/ (* 5 pi) 3)) (<= ug (/ pi 2))))
(defun us6 ()
 (and (> ug (/ pi 2)) (<= ug (/ (* 2 pi) 3))))
(defun us7 ()
 (and (> ug (/ (* 2 pi) 3)) (<= ug (/ (* 3 pi) 2))))
(defun us8 ()
 (and (> ug (/ (* 3 pi) 2)) (<= ug (/ (* 5 pi) 3))))
;      -  
(defun C:RAD (/ ent en pv c r un uk unr ukr pol pt pc ug np
  ts tp pro scf ra ok1 ok ok2 ok3 rt n pr sz drt url pd up
  kp ut utt osnap_def)
 (svars);       

;                   
 (setq ent (entsel "\n \n") en (car ent))
 (while (or (null en) (and
    (/= (cdr (assoc 0 (entget en))) "ARC")
    (/= (cdr (assoc 0 (entget en))) "POLYLINE")))
  (setq ent (entsel
    "\n  , \n")
   en (car ent)))
 (setq pv (cadr ent))
 (if (= (cdr (assoc 0 (entget en))) "POLYLINE") (progn
   (command "EXPLODE" en) (setq en (ssname (ssget pv) 0))
   (while (/= (cdr (assoc 0 (entget en))) "ARC")
    (initget 1)
    (setq pv (getpoint
      "\n  , \n"))
    (setq en (ssname (ssget pv) 0)))))
 (setq c (cdr (assoc 10 (entget en)))
  r (cdr (assoc 40 (entget en)))
  un (cdr (assoc 50 (entget en)))
  uk (cdr (assoc 51 (entget en))))
 (if (< un pi) (setq unr (+ un pi)) (setq unr (- un pi)))
 (if (< uk pi) (setq ukr (+ uk pi)) (setq ukr (- uk pi)))
 (initget "Y y N n")
 (setq pol (getkword
    "\n   ? [y/n] <Y>: "))
 (if (not pol) (setq pol "y"))
 (setq pol (strcase pol T))
 (initget 1)
 (setq pt (getpoint c "\n : ")
  pc (distance c pt))
 (if (= pol "y") (if (>= pc 1.0) (progn
    (setq ug (angle c pt))
    (while (or
      (us2) (us4) (and (us1) (< (abs (- pc r)) 6))
      (= ug un) (= ug uk) (= ug unr) (= ug ukr))
     (initget 1)
     (setq pt (getpoint c
     "\n    , : ")
      pc (distance c pt))
     (if (>= pc 1.0) (setq ug (angle c pt))
      (setq pt c pc 0 ug (angle c pv)))))
   (setq pt c pc 0 ug (angle c pv)))
  (if (>= pc 1.0) (progn (setq ug (angle c pt))
    (while (or (us2) (us4) (and (us1) (< (abs (- pc r)) 6))
      (= ug un) (= ug uk) (= ug unr) (= ug ukr)
      (us6) (us8))
     (initget 1)
     (setq pt (getpoint c
     "\n    , : ")
      pc (distance c pt))
     (if (>= pc 1.0) (setq ug (angle c pt))
      (setq pt c pc 0 ug (angle c pv)))))
   (setq pt c pc 0 ug (angle c pv))))
 (if (= pol "y") (progn (initget 1)
   (setq np (getpoint "\n : "))))
 (initget 1 "I i O o")
 (setq ts (strcase (getkword
    "\n:\n -    <i>,
 -   <o>: ") T))
 (setq tp (getstring T "\n    : "))
 (setq pro (getstring T
   "\n   (  ): "))
 (initget 6)
 (setq scf (getreal "\n   <1>: "))
 (if (not scf) (setq scf 1.0))
 (setvar "BLIPMODE" 0);          
 (setvar "HIGHLIGHT" 0);         
 (setq osnap_def (getvar "OSMODE")) 
 (setvar "OSMODE" 0)
;    (   
;           -  ),
 (setq ra (/ r scf))
 (setq ok1 (rtos ra 2 2))
 (if (/= "0" (substr ok1 (strlen ok1) 1))
  (setq ok ok1))
 (if (=  "0" (substr ok1 (strlen ok1) 1)) (progn
   (setq ok2 (substr ok1 1 (- (strlen ok1) 1)))
   (if (/= "0" (substr ok2 (strlen ok2) 1))
    (setq ok ok2))
   (if (=  "0" (substr ok2 (strlen ok2) 1)) (progn
     (setq ok3 (substr ok2 1 (- (strlen ok1) 3)))
     (setq ok ok3)))))
;            
 (princ "\n   <")
 (princ (strcat tp "R" ok pro))
 (princ "> :")
 (setq rt (getstring T))
 (if (= rt "")  (setq rt (strcat tp "R" ok pro)))
 (setq n 1 pr 0 sz 0)
 (repeat (strlen rt)
  (cond ((= (substr rt n 1) "%") (setq pr (1+ pr)))
   ((= (substr rt n 1) (chr 212)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 214)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 215)) (setq sz (1+ sz)))
   ((= (substr rt n 1) (chr 216)) (setq sz (1+ sz)))
   (T nil))
  (setq n (1+ n)))
 (setq drt (* (- (strlen rt) sz (* (/ pr 2) 5)) 2.5))

;   ,    ,  
 (command "COLOR" "bylayer")
 (command "LAYER" "m" "dim" "c" 3 "dim" (command))
 (command "LINETYPE" "s" "bylayer" (command))
 (command "STYLE" "dim" "eskd" 3.5 0.9 15
  "n" "n" "n")

;      url pd up kp ut utt
 (if (us1) (setq url ug) (setq url (+ ug pi)))
 (setq pd (polar c url r))
 (if (= pol "y") (progn
   (if (< (car np) (car pt)) (setq up pi) (setq up 0))
   (if (and (< (cadr pt) (cadr c))
     (or (and (= up pi) (< (car c) (car pt)))
      (and (= up 0) (> (car c) (car pt)))))
    (setq kp (polar pt up (+ drt 10)))
    (setq kp (polar pt up (+ drt 1))))
   (setq ut 0));      ,  pol="n"
  (progn (cond ((or (and (us1) (>= pc (+ r 6))) (us3))
     (setq kp (polar pt ug (+ drt 1))))
    ((and (us1) (<= pc (- r 6)))
     (setq kp (polar pt (+ ug pi) (+ drt 1)))) (T nil))
   (cond ((or (us5) (<= ug (/ pi 2))) (setq ut ug))
    ((and (us7) (<= ug (/ (* 3 pi) 2)))
     (setq ut (- ug pi)))
    (T nil))))
 (setq utt (+ ut (/ pi 2)))
;             
 (cond ((or (and (= ts "i")
     (or (= pc 0) (us3) (and (us1) (<= pc (- r 6)))))
    (and (= ts "o") (us1) (>= pc (+ r 6))))
   (command "line" kp pt pd (command)))
  ((and (= ts "o")
     (or (= pc 0) (us3) (and (us1) (<= pc (- r 6)))))
   (command "line" kp pt (polar pd url 8) (command)))
  ((and (= ts "i") (us1) (>= pc (+ r 6)))
   (command "line" kp pt (polar pd (+ url pi) 8)
    (command)))
  (T nil))
;               
 (cond ((= ts "i") (command "PLINE"
   (polar pd (+ url pi) 4.5) "w" 1.3 0 pd (command)))
  ((= ts "o") (command "PLINE"
   (polar pd url 4.5) "w" 1.3 0 pd (command))) (T nil))
;           
 (cond ((or (and (= pol "y") (= up pi))
    (and (= pol "n") (or (and (us1) (>= pc (+ r 6)) (us7))
     (and (us3) (us7))
     (and (us1) (<= pc (- r 6)) (us5)))))
   (command "text" (polar kp utt 2) (angtos ut 0 2) rt))
  ((or (and (= pol "y") (= up 0))
    (and (= pol "n") (or (and (us1) (>= pc (+ r 6)) (us5))
     (and (us3) (us5))
     (and (us1) (<= pc (- r 6)) (us7)))))
   (command "text" "r" (polar kp utt 2)
    (angtos ut 0 2) rt))
  (T nil))
 (rvars);      
 (setvar "OSMODE" osnap_def)
 (prin1))